VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "TV Timeline"
   ClientHeight    =   3975
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7710
   DrawWidth       =   8
   ForeColor       =   &H00FFFFFF&
   LinkTopic       =   "Form1"
   ScaleHeight     =   3975
   ScaleWidth      =   7710
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Command4 
      Caption         =   ">"
      Height          =   255
      Left            =   7440
      TabIndex        =   3
      Top             =   0
      Width           =   255
   End
   Begin VB.CommandButton Command3 
      Caption         =   "<"
      Height          =   255
      Left            =   1800
      TabIndex        =   2
      Top             =   0
      Width           =   255
   End
   Begin VB.CommandButton Command2 
      Caption         =   "Down"
      Height          =   255
      Left            =   0
      TabIndex        =   1
      Top             =   3720
      Width           =   1695
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Up"
      Height          =   255
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   1695
   End
   Begin VB.Label Label4 
      Alignment       =   2  'Center
      Caption         =   "8888"
      Height          =   255
      Left            =   6840
      TabIndex        =   7
      Top             =   0
      Width           =   615
   End
   Begin VB.Label Label3 
      Alignment       =   2  'Center
      Caption         =   "8888"
      Height          =   255
      Left            =   4320
      TabIndex        =   6
      Top             =   0
      Width           =   615
   End
   Begin VB.Label Label2 
      Alignment       =   2  'Center
      Caption         =   "8888"
      Height          =   255
      Left            =   2040
      TabIndex        =   5
      Top             =   0
      Width           =   615
   End
   Begin VB.Label Label1 
      Alignment       =   1  'Right Justify
      Caption         =   "Label1"
      Height          =   255
      Index           =   0
      Left            =   0
      TabIndex        =   4
      Top             =   360
      Width           =   1695
   End
   Begin VB.Line Line1 
      BorderColor     =   &H00808000&
      X1              =   1800
      X2              =   1800
      Y1              =   3720
      Y2              =   240
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim basecnum%
Dim basetslot%
Dim topindex%
Dim tvmap$(255, 288)
'first subscript gives up to 256 channels
'Second subscript:
' 288 - channel name
' 0 > 287 - 24hrs in five minute timeslots
'  0 is 0000 to 0005
'   ...
'  287 is 2355 to 2400
'  hours = Int((timeslot * 5) / 60)
'  minutes = timeslot * 5 - Int((timeslot * 5) / 60) * 60
'  timeslot = hours * 12 + Int(minutes / 5)

Sub renderlines()
'Start by matching display elements to form size:
Command2.Height = Command1.Height
Command2.Width = Command1.Width
Command4.Height = Command3.Height
Command4.Width = Command3.Width
Command1.Top = 0
Command1.Left = 0
Command2.Top = Form1.ScaleHeight - Command2.Height
Command2.Left = 0
Line1.X1 = Command1.Width
Line1.X2 = Command1.Width
Line1.Y1 = Command1.Height
Line1.Y2 = Command2.Top
Command3.Left = Command1.Width
Command4.Left = Form1.ScaleWidth - Command4.Width
Command3.Top = 0
Command4.Top = 0
Label3.Width = Label2.Width
Label4.Width = Label2.Width
Label2.Top = 0
Label2.Left = Command3.Left + Command3.Width
Label4.Top = 0
Label4.Left = Command4.Left - Label4.Width
Label3.Top = 0
Label3.Left = Label2.Left + Label2.Width + ((Label4.Left - (Label2.Left + Label2.Width)) / 2 - Label3.Width / 2)
'Put correct times into labels at the top
timeslot% = basetslot%
Label2.Caption = Format(Int((timeslot% * 5) / 60), "00") + ":" + Format(timeslot% * 5 - Int((timeslot% * 5) / 60) * 60, "00")
timeslot% = basetslot% + 6
Label3.Caption = Format(Int((timeslot% * 5) / 60), "00") + ":" + Format(timeslot% * 5 - Int((timeslot% * 5) / 60) * 60, "00")
timeslot% = basetslot% + 12
Label4.Caption = Format(Int((timeslot% * 5) / 60), "00") + ":" + Format(timeslot% * 5 - Int((timeslot% * 5) / 60) * 60, "00")
'enable/disable up/down foward/back buttons as required
If basetslot% < 275 Then
 Command4.Enabled = True
Else
 Command4.Enabled = False
End If
If basetslot% > 0 Then
 Command3.Enabled = True
Else
 Command3.Enabled = False
End If
If basecnum% < 255 Then
 Command2.Enabled = True
Else
 Command2.Enabled = False
End If
If basecnum% > 0 Then
 Command1.Enabled = True
Else
 Command1.Enabled = False
End If
'Render channel names and lines with respect to basecnum and basetslot
id% = 0
For y = Line1.Y1 + 8 * Screen.TwipsPerPixelY To Line1.Y2 Step 16 * Screen.TwipsPerPixelY
 Form1.DrawWidth = 14
 Line (Line1.X1, y)-(Form1.ScaleWidth, y), RGB(0, 64, 192)
 If id% > topindex% Then
  'create a new label
  Load Label1(id%)
  topindex% = id%
 End If
 Label1(id%).Visible = True
 Label1(id%).Left = 0
 Label1(id%).Width = Command1.Width
 Label1(id%).Height = Command2.Height
 Label1(id%).Top = y - 8 * Screen.TwipsPerPixelY - 1
 If id% + basecnum% < 256 Then
  If tvmap$(id% + basecnum%, 288) > "" Then
   Label1(id%).Caption = Format(id% + basecnum%, "0") + ". " + tvmap$(id% + basecnum%, 288) + " "
   'Add breaks to lines when programs change
   l$ = tvmap$(id% + basecnum%, basetslot%)
   Form1.DrawWidth = 2
   For i% = 1 To 12
    If tvmap$(id% + basecnum%, basetslot% + i%) <> l$ Then
     l$ = tvmap$(id% + basecnum%, basetslot% + i%)
     myx = Line1.X1 + (Form1.ScaleWidth - Line1.X1) / 12 * i%
     Line (myx, y + 6 * Screen.TwipsPerPixelY)-(myx, y - 7 * Screen.TwipsPerPixelY), Form1.BackColor
     Form1.Print " " + l$
    End If
   Next i%
  Else
   Label1(id%).Caption = Format(id% + basecnum%, "0") + ". No channel "
  End If
 Else
  Label1(id%).Caption = "No channel "
 End If
 id% = id% + 1
Next y
'Hide redundant labels/lines
highestlabel% = id% - 1
If Label1.Count > highestlabel% + 1 Then
 For i% = highestlabel% + 1 To Label1.Count - 1
  Label1(i%).Visible = False
 Next i%
End If
Line (Command2.Width, Command2.Top)-(Form1.ScaleWidth, Form1.Height), Form1.BackColor, BF
End Sub

Private Sub Command1_Click()
basecnum% = basecnum% - 1
renderlines
End Sub

Private Sub Command2_Click()
basecnum% = basecnum% + 1
renderlines
End Sub

Private Sub Command3_Click()
basetslot% = basetslot% - 1
renderlines
End Sub

Private Sub Command4_Click()
basetslot% = basetslot% + 1
renderlines
End Sub

Private Sub Form_Load()
'Load some dummy data into the tvmap array
tvmap$(0, 288) = "l33t TV"
l% = 0
c% = 1
For i% = 0 To 287
 tvmap$(0, i%) = "Program " + Format(c%, "0")
 l% = l% + 1
 If l% = 6 Then
  c% = c% + 1
  l% = 0
 End If
Next i%
'Set the base timeslot with respect to the current time
t$ = Format(Time, "HHMM")
basetslot% = Val(Mid$(t$, 1, 2)) * 12 + Int(Val(Mid$(t$, 3, 2)) / 5)
If basetslot% > 275 Then
 basetslot% = 275
End If
'Draw form
renderlines
End Sub

Private Sub Form_Paint()
If Form1.WindowState <> 1 Then
 'Do not bother messing around with form if its minimised
 renderlines
End If
End Sub

Private Sub Form_Resize()
If Form1.WindowState <> 1 Then
 'Do not bother messing around with form if its minimised
 renderlines
End If
End Sub

